module TheFuturest
  class Chapter
    attr_accessor :id, :title, :number, :errors
    
    def initialize(attrs)
      @id = attrs["id"]
      @title = attrs["title"]
      @number = attrs["number"]
    end
    
    def self.find(id, query = {})
      response = Text.get("/chapter/#{id}", :query => query)
      self.new response.parsed_response
    end
    
    def self.parse(response)
      chapter = response.parsed_response
      if chapter.is_a? Array
        chapter.map {|c| Chapter.new c }
      else
        Chapter.new chapter
      end
    end
    
    def paragraphs(query = {})
      Paragraph.parse Text.get("/chapter/#{@id}/paragraphs", :query => query)
    end
    
    def save
      response = Text.post("/chapter/#{@id}", :query => { :title => @title, :number => @number }).parsed_response
      @errors = response["errors"] and return false if response["errors"].any?
      true
    end
    
  end
end
