module TheFuturest  
  class Paragraph
    attr_accessor :id, :number, :text, :styled_text, :chapter_id, :errors
    
    def initialize(attrs)
      @id = attrs["id"]
      @number = attrs["number"]
      @text = attrs["text"]
      @styled_text = attrs["styled_text"]
      @chapter_id = attrs["chapter_id"]
    end
    
    def self.parse(response)
      paragraph = response.parsed_response
      if paragraph.is_a? Array
        paragraph.map {|p| Paragraph.new p }
      else
        Paragraph.new paragraph
      end
    end
    
    def chapter
      Chapter.parse Text.get("/chapter/#{@chapter_id}")
    end
    
    def save
      response = Text.post("/chapter/#{@chapter_id}/paragraph/#{@id}", :query => { :text => @text, :number => @number }).parsed_response
      @errors = response["errors"] and return false if response["errors"].any?
      @styled_text = response["paragraph"]["styled_text"]
      return true
    end
    
  end
end
